<?php
/*
 Plugin Name: Paystar Payment Module For VBulletin
 Plugin URI: https://paysar.ir
 Version: 1.0
 Author: Shayan Kiyani
 */
 
if (!isset($GLOBALS['vbulletin'] -> db)) 
	exit;

class vB_PaidSubscriptionMethod_paystar extends vB_PaidSubscriptionMethod 
{
	var $supports_recurring = false;
	var $display_feedback = true;
	function verify_payment() 
	{
		global $vbulletin;
		$this -> registry -> input -> clean_array_gpc('r', array('item' => TYPE_STR));
		$this -> transaction_id = $this -> registry -> GPC['item'];
		if(!empty($this -> registry -> GPC['item'])) 
		{
			$this -> paymentinfo = $this -> registry -> db -> query_first("
			SELECT paymentinfo.*, user.username
			FROM " . TABLE_PREFIX . "paymentinfo AS paymentinfo
			INNER JOIN " . TABLE_PREFIX . "user AS user USING (userid)
			WHERE hash = '" . $this -> registry -> db -> escape_string($this -> registry -> GPC['item']) . "'");
			if (!empty($this -> paymentinfo)) 
			{
				$sub = $this -> registry -> db -> query_first("SELECT * FROM " . TABLE_PREFIX . "subscription WHERE subscriptionid = " . $this -> paymentinfo['subscriptionid']);
				$cost = unserialize($sub['cost']);
				$amount = floor($cost[0][cost][usd]);
				$amount = $amount * 1000;
				$transid = @$_POST['transid'];
				if(!empty($transid))
				{
					$res = false;
					try
					{
						require(dirname(__FILE__) . '/../../paystarconfig.php');
						$f = array(
							'amount' => $amount,
							'pin' => trim($vbulletin->options['paystar_pin']),
							'transid' => $transid,
						);
						
						$f_ = '';
						foreach($f as $k=>$v) 
							$f_ .= $k . '=' . urlencode($v) . '&'; 
							
						rtrim($f_, '&');

						$ch = curl_init();
						curl_setopt($ch,CURLOPT_URL, "https://{$ws_config['address']}/api/verify/");
						curl_setopt($ch,CURLOPT_POST, count($f));
						curl_setopt($ch,CURLOPT_POSTFIELDS, $f_);
						curl_setopt($ch,CURLOPT_RETURNTRANSFER, true);
						$res = curl_exec($ch);
						curl_close($ch);
					}
					catch(Exception $e) 
					{
						$this->error = 'اتصال به بانک برقرار نشد .';
					}
				}
				else
					$this->error = 'پارامترهای ارسالی صحیح نمیباشد .';				
				
				if(empty($res))
					$this->error = 'تراکنش پرداخت نشده است .';
				else if($res == 1) 
				{
					$this -> paymentinfo['currency'] = 'usd';
					$this -> paymentinfo['amount'] = $cost[0][cost][usd];
					$this -> type = 1;
					return true;					
				}
				else
					$this->error = 'پرداخت انجام نشده است . <br/>کد خطا : (' . $res . ')';								
			}
		}		
		return false;
	}

	function test() 
	{
		global $vbulletin;
		try
		{
			require(dirname(__FILE__) . '/../../paystarconfig.php');
			$f = array(
				'amount' => 100,
				'pin' => trim($vbulletin->options['paystar_pin']),
				'callback' => "https://{$ws_config['address']}",
				'bank' => 'parsian',
				'description' => 'test vb'
			);

			$f_ = '';
			foreach($f as $k=>$v) 
				$f_ .= $k . '=' . urlencode($v) . '&'; 
				
			rtrim($f_, '&');

			$ch = curl_init();
			curl_setopt($ch,CURLOPT_URL, "https://{$ws_config['address']}/api/create/");
			curl_setopt($ch,CURLOPT_POST, count($f));
			curl_setopt($ch,CURLOPT_POSTFIELDS, $f_);
			curl_setopt($ch,CURLOPT_RETURNTRANSFER, true);
			$res = curl_exec($ch);
			curl_close($ch); 
			return (strlen($res) > 5) ? true : false;
		}
		catch(Exception $e) 
		{
			return false;
		}		
	}

	function generate_form_html($hash, $cost, $currency, $subinfo, $userinfo, $timeinfo) 
	{
		$item = $hash;
		global $vbphrase, $vbulletin, $show;
		require(dirname(__FILE__) . '/../../paystarconfig.php');

		$cost = floor($cost);
		$form['action'] = 'forum.php?do=pp_subscription&pr' . $item . '=' . $cost;
		$form['method'] = 'POST';
		$settings = &$this -> settings;
		$templater = vB_Template::create('paystar');
		$templater -> register('item', $item);
		$templater -> register('userinfo', $userinfo);
		$templater -> register('wsconfigbank', $ws_config['bank']);
		$templater -> register('paystaraddres', $ws_config['address']);
		
		$form['hiddenfields'] .= $templater -> render();
		return $form;
	}
}
?>